/*
 * main.c
 */

#include <msp430f6638.h>
#include <stdint.h>
#include <stdio.h>
#include "dr_tft.h"

unsigned char flag0=0,flag1=0;
unsigned char send_data[]={'0','\0'};
unsigned char recv_data[]={'0','\0'};


void UART_RS232_Init(void);	//RS232ӿڳʼ
void TimerA_Init(void);		//ʱTAʼ

void main(void)
{
	WDTCTL = WDTPW + WDTHOLD;//رտŹ

	UART_RS232_Init();		//ʼRS232ӿ
	initTFT();				//ʼTFTĻ
	etft_AreaSet(0,0,319,239,0);	//TFT
	TimerA_Init();					//ʼʱ
	_EINT();				//ж

	etft_DisplayString("Send Data: ",80,100,65535,0);	//TFTʾݵıʶ
	etft_DisplayString("Recv Data: ",80,140,65535,0);	//TFTʾݵıʶ

	while(1)
	{
		if(flag0)			//flag0ڶʱʱ1sʱֵΪ1
		{
			flag0=0;
			UCA1TXBUF=send_data[0];		//дһַͻ淢
			etft_DisplayString(send_data,170,100,65535,0);	//TFTʾ͵ַ
			send_data[0]++;				//ַ1
			if(send_data[0]>'9')		//ַ'9''0'
				send_data[0]='0';
		}

		if(flag1)			//flag1ڽжбֵΪ1
		{
			flag1=0;
			etft_DisplayString(recv_data,170,140,65535,0);	//TFTĻʾյַ
		}
	}
}


#pragma vector=USCI_A1_VECTOR	//USCIжϷ
__interrupt void USCI_A1_ISR(void)
{
	switch(__even_in_range(UCA1IV,4))
	{
	case 0:break;			//ж
	case 2:					//жϴ
		while(!(UCA1IFG&UCTXIFG));	//ȴɽ
		recv_data[0]=UCA1RXBUF;		//ݶ
		flag1=1;					//ñʶݵֵ
		break;
	case 4:break;			//жϲ
	default:break;			//޲

	}
}

#pragma vector = TIMER0_A0_VECTOR	//ʱTAжϷ
__interrupt void Timer_A (void)
{
	static unsigned char i=0;
	i++;
	if(i>=20)				//ʮΪ1s
	{
		i=0;
		flag0=1;			//ıʶݵֵ
	}
}


void UART_RS232_Init(void)	//RS232ӿڳʼ
{
	/*ͨP3.4P3.5P4.4P4.5ʵͨѡ
	 	 ʹUSCIлUARTģʽ*/
	P3DIR|=(1<<4)|(1<<5);
	P4DIR|=(1<<4)|(1<<5);
	P4OUT|=(1<<4);
	P4OUT&=~(1<<5);
	P3OUT|=(1<<5);
	P3OUT&=~(1<<4);
	P8SEL|=0x0c;	//ģ鹦ܽӿãP8.2P8.3ΪUSCIĽտ뷢
	UCA1CTL1|=UCSWRST;	//λUSCI
	UCA1CTL1|=UCSSEL_1;	//øʱӣڷض
	UCA1BR0=0x03;		//ò
	UCA1BR1=0x00;
	UCA1MCTL=UCBRS_3+UCBRF_0;
	UCA1CTL1&=~UCSWRST;	//λ
	UCA1IE|=UCRXIE;		//ʹܽж
}

void TimerA_Init(void)		//ʱTAʼ
{
	TA0CTL |= MC_1 + TASSEL_2 + TACLR;	//ʱΪSMCLK,Ƚģʽʼʱ
	TA0CCTL0 = CCIE;					//Ƚжʹ
	TA0CCR0  = 50000;					//ȽֵΪ50000൱50msʱ
}
