#ifndef __DR_AUDIO_IO_H_
#define __DR_AUDIO_IO_H_

#include "fw_queue.h"

#ifndef SMCLK_FREQ
  #define SMCLK_FREQ 20000000
#endif

#define INPUT_AUDIO_BUFFER_LENGTH 1024 //8KԼ125ms
#define OUTPUT_AUDIO_BUFFER_LENGTH 1024 //8KԼ62ms

extern Queue audio_input_stream; //Ƶɴжȡuint8_tƵ
                                  //Ҳʹaudio_InputXXXز
extern Queue audio_output_stream; //Ƶвuint16_t(12λЧ)ԲƵ
                                   //Ҳʹaudio_OutputXXXز

void initAudioIO();

//趨ƵģĲʣλΪHz
void audio_SetSampleRate(uint32_t sr);

//֮ǰĲ
inline void audio_InputClear();

//ȡsizeʵʲ
inline uint16_t audio_InputRead(uint8_t *buff, uint16_t size);

//Ƶһ
inline int audio_Output(uint16_t val);

//Ƶʣռ(Բʽʾ)
inline uint16_t audio_OutputBufferSpace();

//---------------------------------------------------------------------
/* inlineʵ */
static inline void audio_InputClear()
{
  queue_ThrowData(&audio_input_stream, INPUT_AUDIO_BUFFER_LENGTH);
}

static inline uint16_t audio_InputRead(uint8_t *buff, uint16_t size)
{
  return queue_Read(&audio_input_stream, buff, size);
}

static inline int audio_Output(uint16_t val)
{
  return queue_Write(&audio_output_stream,
                      (uint8_t*)&val, sizeof(val));
}

static inline uint16_t audio_OutputBufferSpace() //ƵɵĲ
{
  return (queue_CanWrite(&audio_output_stream) / 2);
}

#endif //__DR_AUDIO_IO_H_
